UNIT COUP_2;

   {------------------------------------------------------------------------}
   {      logiciel GEOCEAN                                                  }
   {                     Module COUPES  -  menu COUPES                      }
   {------------------------------------------------------------------------}

INTERFACE

{$O+,F+}

USES
   Utildivs,                 { ARX     - utilitaires divers                 }
   Menus,                    { ARX     - interface menus                    }

   GEO_VAR,                  { GEO     - variables globales communes        }
   GEO_DES,                  { GEO     - procdures graph. communes         }

   COUP_VAR,                 { COUP    - variables globales du module       }
   COUP_DES;                 { COUP    - graphismes divers                  }

Procedure p_sismi;
Procedure p_topo;
Procedure p_gravi;
Procedure ini_coupe;
   { choix du type de profil                                                }

Procedure chang_coupe (typ : integer);
   { choix du profil affich  la souris                                    }

Procedure extremites;
   { choix des extrmits du profil :                                       }
   {     avec la souris si la carte est visualise,                         }
   {     avec une bote de rglage sinon.                                   }

Procedure chang_extremites (xs, ys : integer);
   { Modifie la position d'une extrmit du trait  avec la souris           }

Procedure d_params_p;
Procedure d_params_l;
   { Largeur / lissage }

Procedure prep_model;
   { Rduit les valeurs calcules en fonction du pas de lissage et visu     }

Procedure change_echelle;
   { Bascule ECHELLE 1 / chelle automatique                                }


{---------------------------------------------------------------------------}

IMPLEMENTATION

procedure p_sismi;
   begin
      sismi     := true;
      gravi     := false;
      topo      := false;
      if visucontours
      then
         redess_carte (false);
   end;

procedure p_topo;
   begin
      sismi     := false;
      gravi     := false;
      topo      := true;
      if visucontours
      then
         redess_carte (false);
   end;

procedure p_gravi;
   begin
      sismi     := false;
      gravi     := true;
      topo      := false;
      if visucontours
      then
         redess_carte (false);
   end;

procedure ini_coupe;
   begin
      entier := 1;
      if sismi
      then
         entier := 3
      else
         if gravi
         then
            entier := 2;
      creeliste (cl_topo,  1);
      creeliste (cl_gravi, 2);
      if nomfd3 <> ''
      then
         creeliste (cl_sismi, 3);
      liste     ('', t_type, '', 25, chain, entier);
      case entier of
         1 : p_topo;
         2 : p_gravi;
         3 : p_sismi;
      end ;
      dess_profil (1, false);
      inietat ;                                                  { des }
   end;

procedure chang_coupe (typ : integer);
   begin
      redess_pro; {     dess_profil (1, false);}
   end;

procedure extremites;
   var
      ax1, ay1,
      ax2, ay2          : real;

   begin
      ax1 := x1;
      ay1 := y1;
      ax2 := x2;
      ay2 := y2;

      if visucarte
      then begin
         enlev_pro;
         extrems;
      end else
         { saisie  manuelle }
         exit;

      modipro := (x1 <> ax1) or (y1 <> ay1) or
                 (x2 <> ax2) or (y2 <> ay2) or modipro;
      if modipro
      then
         calculer
      else
         dess_profil (1, false);
      modipar := modipar or modipro;
   end;

procedure p_extrems (xs, ys : integer);
   var
      ax1, ay1,
      ax2, ay2          : real;

   begin
      ax1 := x1;
      ay1 := y1;
      ax2 := x2;
      ay2 := y2;

      deplace_extrems (xs, ys, x1, y1, x2, y2);

      modipro := (x1 <> ax1) or (y1 <> ay1) or
                 (x2 <> ax2) or (y2 <> ay2) or modipro;
      modipar := modipar or modipro;
   end;

procedure chang_extremites (xs, ys : integer);
   begin
      if visucontours
      then begin
         p_extrems (xs, ys);
         if modipro
         then begin
            gra := false;
            top := false;
            sis := false;
           {age := false;
            flu := false;
            sub := false;}

            efface_profil (2);
            calculer
         end;
      end else
         redess_carte (false);
   end;

procedure d_params_p;
   begin
      choisir_params_p;
      modipar := modipar or modipro;
      if modipro
      then begin
         sis := false;
         efface_profil (2);
         calculer
      end;
   end;

procedure d_params_l;
   begin
      choisir_params_l;
      modipar := modipar or modipro;
      if modipro
      then begin
         gra := false;
         top := false;
         efface_profil (2);
         calculer
      end;
   end;

procedure change_echelle;
   begin
      if visu1
      then begin
         efface_profil (2);
     {    echelle1 := not echelle1;
         recadrer_profils (echelle1);
         dess_profil   (2, false);}
      end else begin
{         echelle1 := not echelle1;
         recadrer_profils (echelle1);
         dess_profil   (2, false); }
      end;
         echelle1 := not echelle1;
         recadrer_profils (echelle1);
         dess_profil   (2, false);
      modipro := true;
      modipar := modipar or modipro;
   end;

procedure prep_model;
   var
      p1, p2, p3        : boolean;

   begin
      p1 := sismi;
      p2 := topo;
      p3 := gravi;

      if modipro
      then
         anomalie_gravi (x1, y1, x2, y2);
         { recalcule vt topo, gravi et corps ; positionne ANOM Vrai }
         { recalcule aussi sismi }

      reduc := not reduc;

      if zoneinconnue and reduc
      then begin
         message (m_inconnu);
         reduc := false;
         anom  := false;
         exit;
      end;

      sismi := true;
      gravi := false;
      topo  := false;
      dess_profil (1, false);

      sismi := false;
      gravi := true;
      dess_profil (1, false);

      gravi := false;
      topo  := true;
      dess_profil (1, false);
      sismi := p1;
      topo  := p2;
      gravi := p3;
      affval_extremites (x1, y1, x2, y2, longpro, nbst);
      modipro := false;
   end;


END.

{--- GEOCEAN - COUP_2 ------------------------ R.C.- INRP - TOULOUSE - 1993 }
