UNIT GRAV_1;

   {------------------------------------------------------------------------}
   { logiciel GEOCEAN - module GRAV                                         }
   {                                                                        }
   {                         menu FICHIERS                                  }
   {                                                       10/10/93         }
   {------------------------------------------------------------------------}

INTERFACE
{$O+,F+}

USES
   Dos,
   Utildivs,                 { ARX     - utilitaires divers                 }
   Periphs,                  { ARX     - interface menus                    }
   Fichiers,                 { ARX     - Gestion des fichiers et erreurs    }
   Dirinfo,                  { ARX     - gestion fichier INFO.DIR           }
   Menus,                    { ARX     - interface menus                    }

   GEO_var,                  { GEO     - variables globales communes        }
   GEO_des,                  { GEO     - procdures graph. communes         }
   GRAV_var,                 { GRAV    - variables globales du module       }
   GRAV_ini,                 { GRAV    - initialisation                     }
   GRAV_des;                 { GRAV    - affichages propres au module       }


(*Procedure ModExo;
   { Bascule accs exos/accs perso                                         }
*)
Procedure voir_parametres;
   { afficher les listes dans une bote  dfilement                        }

Procedure supprimer_lien;
   { Supprimer une rfrence  un fichier "accessoire" }

Procedure modifier_lien;
   { Changer une rfrence  un fichier "accessoire" }

Procedure ouvrir_fichier;
   { slectionner un nom de fichier de paramtres existant dans le          }
   { rpertoire de travail (en cours) et rtablir l'environnement de        }
   { travail associ.                                                       }

Procedure nouveau_fichier;
   { slectionner un nouveau nom pour un nouveau fichier de paramtres      }
   { et rtablir l'environnement standard, vt  partir de GRAV.CRT         }

Procedure enregistrer_fichier;
   { enregistre les paramtres en cours sans changer l'tat de l'cran.     }
   { enregistre aussi les donnes                                           }

Procedure enregistrer_sous;
   { copie les paramtres en cours dans un autre fichier                    }
   { copie aussi les donnes                                                }

Procedure quitter;
   { demander confirmation avant de stopper l'excution                     }


{---------------------------------------------------------------------------}

IMPLEMENTATION

procedure voir_parametres;
   begin
      entier  := 1;
      creeliste (c_Travail, 1);
      creeliste (c_Config , 2);

      liste     (l_params1, l_params2, l_params3, 35, chain, entier);
      case entier of
         1 : voir_ptrav;
         2 : voir_penv;
      end
   end;

procedure  FIC_DONNEES_comm;                   { 1 }
   begin
      chang_comm (nomfcomm);
      effacer_tout_redessiner;
   end;

procedure modifier_lien;
   begin
      FIC_DONNEES_comm;                  { 1 }
      modif_modele := true;
      inietat;
   end;

procedure  s_FIC_DONNEES_comm;                  { 1 }
   begin
      { librer la collection }
      liberer_commentaires;

      { effacer}
      nomfcomm := '';
      visucomm := false;
      ini_par_COMM (nomfcomm + extcom); { commentaires }
      effacer_tout_redessiner;
   end;

procedure supprimer_lien;
   begin
      s_FIC_DONNEES_comm;                  { 1 }
      modif_modele := true;
      inietat;
   end;


procedure verif;
   begin
      ok := true;
      if (modif_modele or modipar or modicomm) and not exempl
      then begin
         question (q_verif1, q_verif2, ok);
         if ok
         then
            if ((nomfpar <> nomdumodule))
            then begin
               ecrire_parametres (true);               { sauver_fichiers }
               modipar  := false;
            end else begin
               message (m_Donner_nom);
               enregistrer_sous;
            end;
      end;
   end;

procedure ouvrir_fichier;
   var
      ok                : boolean;

   begin
{      ok := visucomm;}
      verif;
      efftout;                                                      { des }
      dir_info ('', choix_modele, '',
                 nomfinfo, '*', extPAR, chain);
      nomfpar := sansext (chain);
      if nomfpar = ''
      then
         nomfpar := nomdumodule;
      lire_parametres;
      inidonnees;
      iniecran;                                                    { des }
{      if ok
      then
         effacer_tout_redessiner
      else             }
         redess_modele (false);
    {  inimodele;}
   end;

(*procedure ouvrir_exo;
   var
      d                 : dirstr;
      n                 : namestr;
      e                 : extstr;
      ok                : boolean;

   begin
      verif;
      efftout;                                                      { des }

      dir_info ('', choix_exo, '',
                cheminexo+nomfinfo, '*', extPAR, chain);
      fsplit (chain, d, n, e );

      nomfpar :=  n;
      if nomfpar = ''
      then begin
         nomfpar := nomdumodule;
         exo := false;
      end;
      lire_parametres;
      inidonnees;
      iniecran;                                                    { des }
      redess_modele (false);
      inimodele;
   end;
*)
procedure nouveau_fichier;
   var
      ok                : boolean;

   begin
     { ok := visucomm;}
      verif;
      efftout;
      nomfpar := nomdumodule;

      lire_parametres;
      inidonnees;
      iniecran;
{      if ok
      then
         effacer_tout_redessiner
      else             }
      redess_modele (false);
      inimodele;
  end;

procedure enregistrer_fichier;
   begin
      inietat;
      if nomfpar = nomdumodule
      then
         nomfpar  := nomfdefo (nomdumodule, nomfpar, nomutil);

      if ((nomfpar <> nomdumodule))
      then begin
         ecrire_parametres (true);
         modif_modele := false;
         modicomm     := false;
         modipar      := false;
      end;
   end;

procedure enregistrer_sous;
   var
      ext               : extstr;

   begin
      inietat;
      ext     := extpar;
      ok      := false;
     { chain   := nomfpar;}
      if nomfpar = nomdumodule
      then
         nomfpar  := nomfdefo (nomdumodule, nomfpar, nomutil);

      nomfichier_sortie                                    { menus5 }
         (nomf_nouveau+' : (' +extpar+ ')', '', {chain}nomfpar, ext, ok);
{      nomfpar := chain;  }
      if (nomfpar = nomdumodule) and prof
      then begin
         ok := false;
         question (q_creer1, q_creer2, ok);
      end;
      if ((nomfpar <> nomdumodule) or prof)  and ok
      then begin
         nomfcomm := nomfpar;
         inietat ;
         ecrire_parametres (true);
         modif_modele := false;
         modicomm     := false;
         modipar      := false;
      end else
         message (m_lefichier+' '+nomfpar+' '+m_lefichiers);
   end;

(*procedure ModExo;
   begin
      exo := not exo;
      if exo
      then
         ouvrir_exo;

      if exo
      then message3 ('Choisir NOUVEAU',
                     'pour travailler  partir de donnes',
                     'indpendantes du terrain.'   )
      else message3 ('Choisir Fichiers/Nouveau ou Ouvrir',
                     'pour reprendre le travail',
                     'sur un profil de la rgion.'   )
   end;
*)
procedure quitter;
   begin
      question (q_quitter1, q_quitter2, fini);
      if fini
      then
         verif;
   end;


END.

{--- GEOCEAN - GRAV_1 ------------------------ R.C.- INRP - TOULOUSE - 1993 }
